% Generated by roxygen2 (4.1.1): do not edit by hand
% Please edit documentation in R/fill.outside.border.R
\name{fill.outside.border}
\alias{fill.outside.border}
\title{Fills space outside the border of a plot.}
\usage{
fill.outside.border(col = 0, rat = 1)
}
\arguments{
\item{col}{The color of the fill, default is 0 (usually white).}

\item{rat}{Ratio between the size of the current plot and the size of the
fill, if you want to allow the program to draw 5\% outside the plot you set
rat =1.05.  Default rat = 1.}
}
\value{
No Value.
}
\description{
When programs like geopolygon are used they sometimes fills space outside
the border of their plots, to refill that space white we use
fill.outside.border.
}
\section{Side Effects}{
 Fill outside of the border of the current plot.
}
\examples{
\dontrun{
	geoplot(xlim=c(-50,20),ylim=c(50,70))       # Initialize plot.
       geoworld(fill=T,color=120)                  # Colour countries.
       fill.outside.border()                       # Clear outside of border.
       geoplot(xlim=c(-50,20),ylim=c(50,70),new=T) # Relabel.
}
}
\seealso{
\code{\link{geoworld}}, \code{\link{geopolygon}}.
}
\keyword{<!--Put}
\keyword{here-->}
\keyword{more}
\keyword{one}
\keyword{or}
\keyword{s-keyword}
\keyword{tags}

